# Global pipeline rules (can be narrowed inside each job)
workflow:
  rules:
    - if: '$CI_COMMIT_BRANCH == "master"'
    - if: '$CI_COMMIT_TAG'
    - if: '$CI_PIPELINE_SOURCE == "web"'
    - if: '$CI_PIPELINE_SOURCE == "api"'

# Pipeline stages
stages:
  - "Build and publish"

# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# Pipeline global environment variables
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
variables:
  # Set registry where DockerHub images can be found
  OCI_PROD_REGISTRY: "registry.gitlab.com/woodswallow/hub"
  # Set private registry to work with
  OCI_DEVEL_REGISTRY: "${CI_REGISTRY}/${CI_PROJECT_NAMESPACE}"
  # Enable CI debug & tracing features
  #CI_DEBUG_TRACE: "true"

# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# Default for all jobs
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
default:
  before_script:
    # Enable private GitLab registry
    - docker login
        -u ${CI_REGISTRY_USER}
        -p ${CI_REGISTRY_PASSWORD}
        ${CI_REGISTRY}
  cache: {}
  artifacts: {}

# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# STAGE: Execute user build script
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
OCI image:
  stage: "Build and publish"
  tags:
    - "OCI build"
  # Use 'parallel' as 'variables' field (shown on jobs)
  parallel:
    matrix:
      - OCI_IMAGE_TITLE: "winehq"
        OCI_VARIANT_TITLE:
          - "ubuntu18.04"
          - "ubuntu20.04"
          - "ubuntu20.10"
  script:
    # Pull master as cache, if exists, to avoid layer duplications
    - export OCI_IMAGE_VERSION="master";
    - source set-env.sh
    - docker image pull "${OCI_VARIANT_IMAGE_FQN}" || true;
    # If present, tag will be used instead of the branch name
    - export OCI_IMAGE_VERSION="${CI_COMMIT_BRANCH}";
    - if [ ! "${CI_COMMIT_TAG}" = "" ];
      then
        export OCI_IMAGE_VERSION="${CI_COMMIT_TAG}";
      fi
    - source set-env.sh
    # Build, tag and push image
    - /usr/bin/env bash build-image.sh
    - docker image push "${OCI_VARIANT_IMAGE_FQN}"
    # If present, a tag will also generate a 'latest' tagged image
    - if [ ! "${CI_COMMIT_TAG}" = "" ];
      then
        export OCI_LATEST_SRC_FQN="${OCI_VARIANT_IMAGE_FQN}";
        export OCI_IMAGE_VERSION="latest";
        source set-env.sh;
        docker image tag "${OCI_LATEST_SRC_FQN}" "${OCI_VARIANT_IMAGE_FQN}";
        docker image push "${OCI_VARIANT_IMAGE_FQN}";
      fi
